<template>
  <div class="fixed top-0 z-30 w-full header header-style-three">
    <div class="bg-background3 relative z-[60] flex flex-col">
      <div
        v-loading="isLoading"
        class="container relative mx-auto"
        :class="{ '!w-[1200px]': store.state.selectedThemeName === 'black' }"
      >
        <div class="w-full">
          <div class="w-full flex justify-between items-center h-[54px]">
            <nuxt-link
              v-if="!logo.IsHidden"
              class="flex items-center"
              :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
            >
              <div class="flex justify-start items-center h-12 min-w-[144px] pr-2">
                <img :src="logo.ImagePath" class="w-full h-full"/>
              </div>
            </nuxt-link>
            <div v-else>&nbsp;</div>
            <div class="flex gap-2 h-[32px] items-center">
              <template v-if="auth">
                <div class="mr-2">
                  <utils-tiny-user-center />
                </div>
                <div class="divider"></div>
                <div
                  class="flex items-center justify-end mt-3 mb-2.5"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <div class="flex flex-col items-center mr-2">
                    <span class="text-xs w-full text-right username-text">{{
                      store.state.username
                    }}</span>
                    <utils-balance-information :is-suspended="isSuspendedAccount" />
                  </div>
                  <div class="divider h-8"></div>
                  <div class="flex items-center">
                    <nuxt-link
                      v-if="isCashPlayer && isShowDepositWithdrawal"
                      id="depositBtn"
                      to="/deposit"
                      class="px-2 py-1.5 mx-2 rounded btn --secondary --textBtn h-8"
                    >
                      <b class="--textBtn font-medium uppercase">{{ $t(`deposit${isBhinbhin}`) }}</b>
                    </nuxt-link>
                    <nuxt-link
                      v-if="!agentCooperation.IsHidden"
                      to="/agent-cooperation"
                      class="px-2 py-1.5 mr-2 btn --tertiary rounded --textBtn"
                      ><b class="--textBtn font-medium">{{ $t("agent_cooperation") }}</b>
                    </nuxt-link>
                  </div>
                </div>
              </template>
              <div class="flex items-center">
                <template v-if="!auth">
                  <nuxt-link
                    id="loginBtn"
                    to="/login"
                    class="px-4 py-2 mr-2 btn rounded h-8 !min-w-[76px] !flex items-center --secondary --textBtn"
                    ><b class="--textBtn font-medium">{{ $t("capital_login") }}</b></nuxt-link
                  >
                  <nuxt-link
                    v-if="!register.IsHidden"
                    id="signupBtn"
                    to="/register"
                    class="px-2 py-1.5 mr-2 rounded btn --primary --textBtn"
                    ><b class="--textBtn font-medium">{{ $t("joinnow") }}</b></nuxt-link
                  >
                </template>
                <div class="divider"></div>
                <div class="ml-2 flex flex-nowrap items-center">
                  <utils-language />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="flex items-center justify-between h-[40px] mb-3">
        <div
          class="container relative mx-auto h-full bg-background5 rounded"
        >
          <div class="h-full flex justify-between">
            <div class="flex items-center">
              <ul class="flex items-center justify-end capitalize h-full">
                <li
                  class="p-4 cursor-pointer nav-item --text3 h-full flex items-center rounded-tl-[4px] rounded-bl-[4px]"
                  :class="[
                    tabSelected === '/' ? 'active-li' : 'inactive-li',
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    class="header-height w-max menu-tab-hover-animated !h-full"
                    to="/"
                    :class="[
                      {
                        'active-menu': tabSelected === '/',
                      },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                  >
                    <div class="flex pr-1 items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon svg-name="icon-home" class="w-3 h-3" />
                        </div>
                      </div>
                      <span class="uppercase font-medium">
                        {{ $t("home") }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-for="tab in menuTabHeaders"
                  :key="tab"
                  class="p-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  :class="[
                    tabSelected === tab.TabURL?.toLowerCase() ||
                    testActiveGame(tab.TabType, activeTab)
                      ? 'active-li'
                      : 'inactive-li',
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  @mouseover="productListFeatureHover(tab.TabType, tab.TabURL)"
                >
                  <nuxt-link
                    :to="tab.TabURL"
                    :class="[
                      {
                        'active-menu':
                          tabSelected === tab.TabURL?.toLowerCase() ||
                          testActiveGame(tab.TabType, activeTab),
                      },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                    class="header-height w-max menu-tab-hover-animated --text3 !h-full"
                  >
                    <div class="flex flex-nowrap justify-center items-center">
                      <div class="flex pr-1 items-center">
                        <div class="content">
                          <div class="icon-container">
                            <SvgIcon
                              :svg-name="getIcon(tab.TabType)"
                              class="w-3 h-3"
                            />
                          </div>
                        </div>
                      </div>
                      <span class="uppercase font-medium">
                        {{ $t(tab.TabLanguage) }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-if="isAllowPromotionTab"
                  class="p-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  :class="[
                    tabSelected === '/promotion' ? 'active-li' : 'inactive-li',
                    { uppercase: isVietnamLangBlackTheme },
                  ]"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    to="/promotion"
                    :class="[
                      { 'active-menu': tabSelected === '/promotion' },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                    class="header-height w-max menu-tab-hover-animated !h-full"
                  >
                    <div class="flex items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon
                            svg-name="icon-promotion-2"
                            class="w-3 h-3"
                          />
                        </div>
                      </div>
                      <span class="uppercase font-medium">
                        {{ $t("promotion") }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-if="isAppDownloadEnabled"
                  class="p-4 cursor-pointer nav-item --text3 h-full flex items-center rounded-tr-[4px] rounded-br-[4px]"
                  :class="
                    tabSelected === '/app-download'
                      ? 'active-li'
                      : 'inactive-li'
                  "
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    to="/app-download"
                    :class="{ 'active-menu': tabSelected === '/app-download' }"
                    class="header-height w-max menu-tab-hover-animated !h-full"
                  >
                    <div class="flex items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon svg-name="icon-download" class="w-3 h-3" />
                        </div>
                      </div>
                      <span class="uppercase font-medium">
                        {{ $t("app_download") }}
                      </span>
                    </div>
                  </nuxt-link>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
      <div class="py-2 border-t-2 border-background-4 bg-background1 m-notice">
        <div
          class="container flex items-center mx-auto"
          :class="announcement.IsHidden ? 'justify-end' : ''"
        >
          <utils-announcement
            v-if="!announcement.IsHidden"
            :announcement="announcement.Text"
          />
          <utils-display-time
            class="text-right ml-2"
            :need-vertical-line="false"
          />
        </div>
      </div>
    </div>
    <product-feature-tab-hover
      v-model:is-feature-hover="isFeatureContentEnabled"
      :component-key="componentKey"
      :feature-products="filterProductFeature"
    />
  </div>
  <div class="h-[144px]"></div>
</template>

<script lang="ts">
import { PropType, computed, defineComponent } from "vue";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import commonHelper from "@/utils/commonHelper";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "HeaderStyleFour",
  props: {
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const { getAssetImage, isBhinbhin } = commonHelper;
    const {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      isAppDownloadEnabled,
      username,
      logout,
      isCashPlayer,
      isShowDepositWithdrawal,
      componentKey,
      isReferralV2Enabled,
    } = useHeaderComponent();
    const route = useRoute();
    const activeTab = computed(() => route.query.tab ?? "");
    const testActiveGame = (tabType: string, activeGame: string): boolean => {
      const temTabType = tabType
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      const temActiveGame = activeGame
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      return temActiveGame === temTabType;
    };
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );

    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const facebook = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
        EnumThemePropertyKey.HtmlId,
        "facebook_link"
      )
    );

    const isVietnamLangBlackTheme = computed(
      () =>
        store.state.locale === "vi_VN" &&
        store.state.selectedThemeName === "black"
    );
    const getLabel = (tabType: string) => {
      return tabType.replace(" ", "_").toLowerCase();
    };
    const getIcon = (tabType: string) => {
      return `icon-${tabType.toLowerCase().replace(" ", "-")}`;
    };
    return {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      announcement,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      activeTab,
      testActiveGame,
      logo,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      isAppDownloadEnabled,
      getAssetImage,
      isShowDepositWithdrawal,
      isCashPlayer,
      username,
      logout,
      componentKey,
      isVietnamLangBlackTheme,
      store,
      isReferralV2Enabled,
      facebook,
      getLabel,
      getIcon,
      isBhinbhin,
    };
  },
});
</script>
<style lang="scss">
.header-style-three {
  .announcement-container {
    --bg-base-color: var(--background1);
    --bg-opacity: 0.05;
  }
  .display-time-container {
    padding-left: 0;
    .display-time-text {
      padding-left: 0;
    }
  }
  .icon-lang {
    height: 16px;
    width: 22px;
    border-radius: 2px;
    outline: 1px solid var(--border);

    img {
      border-radius: 2px;
    }
  }
  #headerBalanceDisplay {
    font-size: 12px;
  }
  .balance-currency {
    padding-right: 4px;
  }
  .menu-tab-hover-animated {
    color: var(--text3) !important;
    &::after {
      display: none;
    }
    &::before {
      display: none;
    }
    svg {
      fill: var(--text5);
      opacity: 1;
    }
    &:hover {
      svg {
        fill: var(--text5);
      }
      &::after {
        display: none;
      }
    }
  }
  .active-menu {
    color: var(--textBtn) !important;
    &.menu-tab-hover-animated {
      svg {
        fill: var(--textBtn);
      }
    }
  }
  .divider {
    width: 1px;
    height: 100%;
    background: var(--border);
  }
  .active-li {
    background: var(--primary);
  }
  .nav-item {
    &.inactive-li {
      &:hover {
        background: linear-gradient(
            0deg,
            rgba(255, 255, 255, 0.05) 0%,
            rgba(255, 255, 255, 0.05) 100%
          ),
          var(--background5);
        border-top: solid var(--primary) 2px;
      }
    }
  }
  .isFeatureHover {
    top: 100px;
  }
  .username-text {
    color: var(--text3);
  }
  .announcement-icon svg {
    height: 16px;
    width: 16px;
  }
}
</style>
<style lang="postcss" scoped>
.bg-header {
  background-color: var(--background3);
}
.header-height {
  height: 40px;
  display: flex;
  align-items: center;
  position: relative;
}
.nav-item .active-menu,
.nav-item:hover .header-height {
  color: var(--selected);
}
.nav-item .active-menu::before,
.nav-item:hover .header-height::before {
  background-color: var(--selected);
  bottom: 0;
  content: "";
  height: 0.125rem;
  left: 0;
  position: absolute;
  width: 100%;
}
.m-notice {
  height: 36px;
}
.fb-btn {
  min-width: 100px;
}
:deep(.star-icon) {
  right: -12px;
}
:deep(.language-dropdown .dropdown-list-menu) {
  gap: 8px;
}
</style>
